'use strict';

var clientPersonalization = require('@algolia/client-personalization');
var requesterCommon = require('@algolia/requester-common');

/**
 * @deprecated The `@algolia/client-recommendation` package is deprecated and you should use `@algolia/client-personalization` instead. To migrate, install the new package and replace `createRecommendationClient` with `createPersonalizationClient`.
 */
const createRecommendationClient = options => {
    /* eslint-disable max-len */
    options.logger.info('The `@algolia/client-recommendation` package is deprecated and you should use `@algolia/client-personalization` instead.\n' +
        'To migrate, install the new package and replace `createRecommendationClient` with `createPersonalizationClient`.');
    /* eslint-enable max-len */
    return clientPersonalization.createPersonalizationClient(options);
};

const getPersonalizationStrategy = (base) => {
    return (requestOptions) => {
        return base.transporter.read({
            method: requesterCommon.MethodEnum.Get,
            path: '1/strategies/personalization',
        }, requestOptions);
    };
};

const setPersonalizationStrategy = (base) => {
    return (personalizationStrategy, requestOptions) => {
        return base.transporter.write({
            method: requesterCommon.MethodEnum.Post,
            path: '1/strategies/personalization',
            data: personalizationStrategy,
        }, requestOptions);
    };
};

exports.createRecommendationClient = createRecommendationClient;
exports.getPersonalizationStrategy = getPersonalizationStrategy;
exports.setPersonalizationStrategy = setPersonalizationStrategy;
