"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPluginConfiguration = void 0;
const tslib_1 = require("tslib");
const package_json_1 = tslib_1.__importDefault(require("@yarnpkg/cli/package.json"));
const getDynamicLibs_1 = require("./getDynamicLibs");
function getPluginConfiguration() {
    const plugins = new Set();
    for (const dependencyName of package_json_1.default[`@yarnpkg/builder`].bundles.standard)
        plugins.add(dependencyName);
    const modules = (0, getDynamicLibs_1.getDynamicLibs)();
    for (const plugin of plugins)
        modules.set(plugin, require(plugin).default);
    return { plugins, modules };
}
exports.getPluginConfiguration = getPluginConfiguration;
