"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.openWorkspace = void 0;
const core_1 = require("@yarnpkg/core");
const WorkspaceRequiredError_1 = require("./WorkspaceRequiredError");
async function openWorkspace(configuration, cwd) {
    const { project, workspace } = await core_1.Project.find(configuration, cwd);
    if (!workspace)
        throw new WorkspaceRequiredError_1.WorkspaceRequiredError(project.cwd, cwd);
    return workspace;
}
exports.openWorkspace = openWorkspace;
