/// <reference types="node" />
import { FakeFS, PortablePath } from '@yarnpkg/fslib';
import { ZipCompression } from '@yarnpkg/libzip';
export interface ExtractBufferOptions {
    prefixPath?: PortablePath;
    stripComponents?: number;
}
export declare type ConvertToZipPayload = {
    tmpFile: PortablePath;
    tgz: Buffer | Uint8Array;
    extractBufferOpts: ExtractBufferOptions;
    compressionLevel: ZipCompression;
};
export declare function convertToZipWorker(data: ConvertToZipPayload): Promise<PortablePath>;
export declare function extractArchiveTo<T extends FakeFS<PortablePath>>(tgz: Buffer, targetFs: T, { stripComponents, prefixPath }?: ExtractBufferOptions): Promise<T>;
