"use strict";
// This file shouldn't import other libui files, ink, or react.
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkRequirements = void 0;
const tslib_1 = require("tslib");
const os_1 = tslib_1.__importDefault(require("os"));
function checkRequirements({ stdout }) {
    if (os_1.default.endianness() === `BE`)
        throw new Error(`Interactive commands cannot be used on big-endian systems because ink depends on yoga-layout-prebuilt which only supports little-endian architectures`);
    if (!stdout.isTTY) {
        throw new Error(`Interactive commands can only be used inside a TTY environment`);
    }
}
exports.checkRequirements = checkRequirements;
