"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cli_1 = require("@yarnpkg/cli");
const core_1 = require("@yarnpkg/core");
const fslib_1 = require("@yarnpkg/fslib");
const clipanion_1 = require("clipanion");
// eslint-disable-next-line arca/no-default-export
class EntryCommand extends cli_1.BaseCommand {
    constructor() {
        super(...arguments);
        this.leadingArgument = clipanion_1.Option.String();
        this.args = clipanion_1.Option.Proxy();
    }
    async execute() {
        if (this.leadingArgument.match(/[\\/]/) && !core_1.structUtils.tryParseIdent(this.leadingArgument)) {
            const newCwd = fslib_1.ppath.resolve(this.context.cwd, fslib_1.npath.toPortablePath(this.leadingArgument));
            return await this.cli.run(this.args, { cwd: newCwd });
        }
        else {
            return await this.cli.run([`run`, this.leadingArgument, ...this.args]);
        }
    }
}
exports.default = EntryCommand;
