/// <reference types="node" />
import { BaseCommand } from '@yarnpkg/cli';
import { Configuration, Report } from '@yarnpkg/core';
import { Usage } from 'clipanion';
export declare type Tags = {
    latest: Record<string, string>;
    tags: Array<string>;
};
export default class SetVersionCommand extends BaseCommand {
    static paths: string[][];
    static usage: Usage;
    useYarnPath: boolean | undefined;
    onlyIfNeeded: boolean;
    version: string;
    execute(): Promise<0 | 1>;
}
export declare function resolveRange(configuration: Configuration, request: string): Promise<string>;
export declare function resolveTag(configuration: Configuration, request: `stable` | `canary`): Promise<string>;
export declare function setVersion(configuration: Configuration, bundleVersion: string | null, fetchBuffer: () => Promise<Buffer>, { report, useYarnPath }: {
    report: Report;
    useYarnPath?: boolean;
}): Promise<{
    bundleVersion: string;
}>;
