import { BaseCommand } from '@yarnpkg/cli';
import { Configuration, CommandContext, Report } from '@yarnpkg/core';
import { PortablePath } from '@yarnpkg/fslib';
import { Usage } from 'clipanion';
export default class SetVersionSourcesCommand extends BaseCommand {
    static paths: string[][];
    static usage: Usage;
    installPath: string | undefined;
    repository: string;
    branch: string;
    plugins: string[];
    dryRun: boolean;
    noMinify: boolean;
    force: boolean;
    skipPlugins: boolean;
    execute(): Promise<0 | 1>;
}
export declare function runWorkflow(workflow: Array<Array<string>>, { configuration, context, target }: {
    configuration: Configuration;
    context: CommandContext;
    target: PortablePath;
}): Promise<void>;
export declare type PrepareSpec = {
    branch: string;
    context: CommandContext;
    force: boolean;
    repository: string;
};
export declare function prepareRepo(spec: PrepareSpec, { configuration, report, target }: {
    configuration: Configuration;
    report: Report;
    target: PortablePath;
}): Promise<void>;
