"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GithubFetcher = exports.githubUtils = void 0;
const tslib_1 = require("tslib");
const GithubFetcher_1 = require("./GithubFetcher");
Object.defineProperty(exports, "GithubFetcher", { enumerable: true, get: function () { return GithubFetcher_1.GithubFetcher; } });
const githubUtils = tslib_1.__importStar(require("./githubUtils"));
exports.githubUtils = githubUtils;
const plugin = {
    hooks: {
        async fetchHostedRepository(previous, locator, opts) {
            if (previous !== null)
                return previous;
            const fetcher = new GithubFetcher_1.GithubFetcher();
            if (!fetcher.supports(locator, opts))
                return null;
            try {
                return await fetcher.fetch(locator, opts);
            }
            catch (error) {
                return null;
            }
        },
    },
};
// eslint-disable-next-line arca/no-default-export
exports.default = plugin;
