import { Locator } from '@yarnpkg/core';
export declare enum Environment {
    All = "all",
    Production = "production",
    Development = "development"
}
export declare enum Severity {
    Info = "info",
    Low = "low",
    Moderate = "moderate",
    High = "high",
    Critical = "critical"
}
export interface AuditMetadata {
    id: number | string;
    url?: string;
    title: string;
    severity: Severity;
    vulnerable_versions: string;
}
export declare type AuditExtendedMetadata = AuditMetadata & {
    dependents: Array<Locator>;
    versions: Array<string>;
};
export declare type AuditResponse = Record<string, Array<AuditMetadata>>;
export declare type AuditExtendedResponse = Record<string, Array<AuditExtendedMetadata>>;
