import { Project, Workspace, treeUtils, Descriptor, Locator } from '@yarnpkg/core';
import * as npmAuditTypes from './npmAuditTypes';
export declare const allSeverities: npmAuditTypes.Severity[];
export declare function getSeverityInclusions(severity?: npmAuditTypes.Severity): Set<npmAuditTypes.Severity>;
export declare function getReportTree(result: npmAuditTypes.AuditExtendedResponse): treeUtils.TreeNode;
export declare type TopLevelDependency = {
    workspace: Workspace;
    dependency: Descriptor;
};
export declare function getTopLevelDependencies(project: Project, workspace: Workspace, { all, environment }: {
    all: boolean;
    environment: npmAuditTypes.Environment;
}): TopLevelDependency[];
export declare function getPackages(project: Project, roots: Array<TopLevelDependency>, { recursive }: {
    recursive: boolean;
}): Map<string, Map<string, Locator[]>>;
