import { Configuration, Manifest, Ident } from '@yarnpkg/core';
export declare enum RegistryType {
    AUDIT_REGISTRY = "npmAuditRegistry",
    FETCH_REGISTRY = "npmRegistryServer",
    PUBLISH_REGISTRY = "npmPublishRegistry"
}
export interface MapLike {
    get(key: string): any;
}
export declare function normalizeRegistry(registry: string): string;
export declare function getAuditRegistry({ configuration }: {
    configuration: Configuration;
}): string;
export declare function getPublishRegistry(manifest: Manifest, { configuration }: {
    configuration: Configuration;
}): string;
export declare function getScopeRegistry(scope: string | null, { configuration, type }: {
    configuration: Configuration;
    type?: RegistryType;
}): string;
export declare function getDefaultRegistry({ configuration, type }: {
    configuration: Configuration;
    type?: RegistryType;
}): string;
export declare function getRegistryConfiguration(registry: string, { configuration }: {
    configuration: Configuration;
}): MapLike | null;
export declare function getScopeConfiguration(scope: string | null, { configuration }: {
    configuration: Configuration;
}): MapLike | null;
export declare function getAuthConfiguration(registry: string, { configuration, ident }: {
    configuration: Configuration;
    ident?: Ident;
}): MapLike;
