/// <reference types="node" />
import { Ident } from '@yarnpkg/core';
import { Workspace } from '@yarnpkg/core';
import { PortablePath } from '@yarnpkg/fslib';
declare type PublishAdditionalParams = {
    access: string | undefined;
    tag: string;
    registry: string;
    gitHead?: string;
};
export declare function makePublishBody(workspace: Workspace, buffer: Buffer, { access, tag, registry, gitHead }: PublishAdditionalParams): Promise<{
    _id: string;
    _attachments: {
        [x: string]: {
            content_type: string;
            data: string;
            length: number;
        };
    };
    name: string;
    access: string;
    "dist-tags": {
        [x: string]: string;
    };
    versions: {
        [x: string]: {
            _id: string;
            name: string;
            version: string;
            gitHead: string | undefined;
            dist: {
                shasum: string;
                integrity: any;
                tarball: string;
            };
        };
    };
    readme: string;
}>;
export declare function getGitHead(workingDir: PortablePath): Promise<string | undefined>;
export declare function getPublishAccess(workspace: Workspace, ident: Ident): string;
export declare function getReadmeContent(workspace: Workspace): Promise<string>;
export {};
