import { Plugin, Workspace } from '@yarnpkg/core';
import PackCommand from './commands/pack';
import * as packUtils from './packUtils';
export { PackCommand };
export { packUtils };
export interface Hooks {
    /**
     * Called before a workspace is packed. The `rawManifest` value passed in
     * parameter is allowed to be mutated at will, with the changes being only
     * applied to the packed manifest (the original one won't be mutated).
     */
    beforeWorkspacePacking?: (workspace: Workspace, rawManifest: object) => Promise<void> | void;
}
declare const _default: Plugin<any>;
export default _default;
