import { FakeFS, PortablePath } from '@yarnpkg/fslib';
import { ParsedPatchFile, FilePatch } from './parse';
export declare function applyPatchFile(effects: ParsedPatchFile, { baseFs, dryRun, version }?: {
    baseFs?: FakeFS<PortablePath>;
    dryRun?: boolean;
    version?: string | null;
}): Promise<void>;
/**
 * How does noNewLineAtEndOfFile work?
 *
 * if you remove the newline from a file that had one without editing other bits:
 *
 *    it creates an insertion/removal pair where the insertion has \ No new line at end of file
 *
 * if you edit a file that didn't have a new line and don't add one:
 *
 *    both insertion and deletion have \ No new line at end of file
 *
 * if you edit a file that didn't have a new line and add one:
 *
 *    deletion has \ No new line at end of file
 *    but not insertion
 *
 * if you edit a file that had a new line and leave it in:
 *
 *    neither insertion nor deletion have the annotation
 *
 */
export declare function applyPatch({ hunks, path }: FilePatch, { baseFs, dryRun }: {
    baseFs: FakeFS<PortablePath>;
    dryRun?: boolean;
}): Promise<void>;
