"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reportHunk = void 0;
const core_1 = require("@yarnpkg/core");
const parse_1 = require("./parse");
function reportHunk(hunk, { configuration, report }) {
    for (const part of hunk.parts) {
        for (const line of part.lines) {
            switch (part.type) {
                case parse_1.PatchMutationType.Context:
                    {
                        report.reportInfo(null, `  ${core_1.formatUtils.pretty(configuration, line, `grey`)}`);
                    }
                    break;
                case parse_1.PatchMutationType.Deletion:
                    {
                        report.reportError(core_1.MessageName.FROZEN_LOCKFILE_EXCEPTION, `- ${core_1.formatUtils.pretty(configuration, line, core_1.formatUtils.Type.REMOVED)}`);
                    }
                    break;
                case parse_1.PatchMutationType.Insertion:
                    {
                        report.reportError(core_1.MessageName.FROZEN_LOCKFILE_EXCEPTION, `+ ${core_1.formatUtils.pretty(configuration, line, core_1.formatUtils.Type.ADDED)}`);
                    }
                    break;
                default: {
                    core_1.miscUtils.assertNever(part.type);
                }
            }
        }
    }
}
exports.reportHunk = reportHunk;
