import { Hooks as CoreHooks, Plugin, Project } from '@yarnpkg/core';
import { PortablePath } from '@yarnpkg/fslib';
import { Hooks as StageHooks } from '@yarnpkg/plugin-stage';
import UnplugCommand from './commands/unplug';
import * as jsInstallUtils from './jsInstallUtils';
import * as pnpUtils from './pnpUtils';
export { UnplugCommand };
export { jsInstallUtils };
export { pnpUtils };
export declare const getPnpPath: (project: Project) => {
    cjs: PortablePath;
    data: PortablePath;
    esmLoader: PortablePath;
};
export declare const quotePathIfNeeded: (path: string) => string;
declare module '@yarnpkg/core' {
    interface ConfigurationValueMap {
        nodeLinker: string;
        winLinkType: string;
        pnpMode: string;
        pnpShebang: string;
        pnpIgnorePatterns: Array<string>;
        pnpEnableEsmLoader: boolean;
        pnpEnableInlining: boolean;
        pnpFallbackMode: string;
        pnpUnpluggedFolder: PortablePath;
    }
}
declare const plugin: Plugin<CoreHooks & StageHooks>;
export { PnpInstaller, PnpLinker } from './PnpLinker';
export default plugin;
