#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const clipanion_1 = require("clipanion");
const SdkCommand_1 = tslib_1.__importDefault(require("./commands/SdkCommand"));
const cli = new clipanion_1.Cli({
    binaryLabel: `Yarn SDKs`,
    binaryName: `sdks`,
    binaryVersion: require(`@yarnpkg/sdks/package.json`).version,
});
cli.register(SdkCommand_1.default);
cli.register(clipanion_1.Builtins.DefinitionsCommand);
cli.register(clipanion_1.Builtins.HelpCommand);
cli.register(clipanion_1.Builtins.VersionCommand);
cli.runExit(process.argv.slice(2), clipanion_1.Cli.defaultContext);
